Last Comment Bug 774772 - Launching of a web application with a l10n build results in a XUL error - app fails to launch
: Launching of a web application with a l10n build results in a XUL error - app...
Status: VERIFIED FIXED
[blocking-webrtdesktop1+], [qa!]
: regression
Product: Firefox Graveyard
Classification: Graveyard
Component: Web Apps (show other bugs)
: 16 Branch
: All All
: P1 critical
: Firefox 17
Assigned To: Mike Hommey [:glandium]
: Jason Smith [:jsmith]
Mentors:
Depends on:
Blocks: 762864
  Show dependency treegraph
 
Reported: 2012-07-17 11:30 PDT by Jason Smith [:jsmith]
Modified: 2016-02-04 15:00 PST (History)
13 users (show)
ryanvm: in‑testsuite-
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Fix webapprt l10n after bug 762864 (2.88 KB, patch)
2012-07-17 23:36 PDT, Mike Hommey [:glandium]
benjamin: review+
akeybl: approval‑mozilla‑aurora+
Details | Diff | Review

Description Jason Smith [:jsmith] 2012-07-17 11:30:30 PDT
Steps:

1. Install a l10n build here - ftp://ftp.mozilla.org/pub/firefox/nightly/latest-mozilla-central-l10n/ for a particular locale (I tested AF and JA)
2. Launch the build
3. Install a web app from apps.mozillalabs.coma/appdir
4. Launch the web app

Expected:

The app should launch - menus should be localized.

Actual:

The app fails to launch with a XUL error. So far seen on AF and JA locales.

Example error in Japanese:

XML パースエラー: 定義されていない実体が使用されています。
URL: chrome://webapprt/content/webapp.xul
行番号: 32, 列番号: 3:  <key id="key_undo"
--^
Comment 1 Jason Smith [:jsmith] 2012-07-17 11:53:00 PDT
Regression testing has shown so far:

- 7/17/2012 l10n build: Busted
- 7/14/2012 l10n build: Busted
- 7/11/2012 l10n build: Working
Comment 2 Anant Narayanan [:anant] 2012-07-17 14:28:39 PDT
The error translates to (courtesy of Google translate):

XML parse error: entity not defined has been used.
URL: chrome://webapprt/content/webapp.xul
line number 32, column number 3: <key id = "key_undo"
Comment 3 Anant Narayanan [:anant] 2012-07-17 15:02:49 PDT
Okay, I was able to reproduce this on a en-GB build. Definitely a l10n issue.
Comment 4 Anant Narayanan [:anant] 2012-07-17 15:16:43 PDT
An app fails to launch with any localized version. Likely an issue with the DTD include in webapp.xul.
Comment 5 Ed Lee :Mardak 2012-07-17 15:20:46 PDT
Unpacking omni.ja from these builds show no webapprt directory:

chrome/en-GB/locale/webapprt doesn't exist

Only these directories exist at chrome/en-GB/locale:

branding       browser        browser-region en-GB          feedback       pdfviewer
Comment 6 Anant Narayanan [:anant] 2012-07-17 15:27:15 PDT
Regression is from bug 762864.
Comment 7 Ed Lee :Mardak 2012-07-17 15:30:35 PDT
I do see the expected locale files here,
webapprt/chrome/en-GB/locale/webapprt

Perhaps this isn't the right way to reference that file:
chrome://webapprt/locale/webapp.dtd
Comment 8 Ed Lee :Mardak 2012-07-17 15:33:32 PDT
contents of webapprt/chrome/en-GB.manifest:
locale webapprt en-GB en-GB/locale/webapprt/

with this directory structure for chrome:

./chrome
./chrome/en-GB
./chrome/en-GB/locale
./chrome/en-GB/locale/webapprt
./chrome/en-GB/locale/webapprt/webapp.dtd
./chrome/en-GB/locale/webapprt/webapp.properties
./chrome/en-GB.manifest
Comment 9 Mike Hommey [:glandium] 2012-07-17 22:59:53 PDT
The problem is that webapprt/omni.ja!/chrome.manifest contains manifest chrome/en-US.manifest instead of manifest chrome/$(AB_CD).manifest.
Comment 10 Mike Hommey [:glandium] 2012-07-17 23:36:27 PDT
Created attachment 643262 [details] [diff] [review]
Fix webapprt l10n after bug 762864
Comment 11 Ryan VanderMeulen [:RyanVM] 2012-07-18 18:10:47 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/179df699d81f
Comment 12 Mike Hommey [:glandium] 2012-07-19 00:46:20 PDT
https://hg.mozilla.org/mozilla-central/rev/768eb7111521
Comment 13 Axel Hecht [:Pike] 2012-07-19 02:17:17 PDT
Jason, it'd be great if you could verify this, AFAICT, we should get aurora approval on this.
Comment 14 Mike Hommey [:glandium] 2012-07-19 02:21:34 PDT
This is not in a nightly yet. I was waiting for a nightly to come up to double check and request an aurora approval.
Comment 15 Mike Hommey [:glandium] 2012-07-19 04:41:56 PDT
7/19 nightlies are up and the l10n packages look good. Jason, please confirm that they work properly. Thanks.
Comment 16 Ed Morley [:emorley] 2012-07-19 07:31:59 PDT
https://hg.mozilla.org/mozilla-central/rev/179df699d81f
Comment 17 Jason Smith [:jsmith] 2012-07-19 08:46:13 PDT
Verified on the 7/19 l10n build on Windows 7 by installing and launching 4 distinct apps. Note although launching is fixed, there's still problems in the menu and notification localization (i.e. it isn't being localized), but I'll file separate bugs for that. That shouldn't block an uplift though.

Please nominate for aurora uplift when you get the chance.
Comment 18 Jason Smith [:jsmith] 2012-07-19 08:47:52 PDT
I should clarify - When I say it isn't being localized, I mean not everything is localized. The words "File," "Quit," "Edit", and everything in the application installed notification isn't localized. The menu under the edit menu is localized.
Comment 19 Mike Hommey [:glandium] 2012-07-22 09:00:27 PDT
(In reply to Jason Smith [:jsmith] from comment #18)
> I should clarify - When I say it isn't being localized, I mean not
> everything is localized. The words "File," "Quit," "Edit", and everything in
> the application installed notification isn't localized. The menu under the
> edit menu is localized.

How was it before bug 762864 landed?
Comment 20 Jason Smith [:jsmith] 2012-07-22 09:15:16 PDT
(In reply to Mike Hommey [:glandium] from comment #19)
> (In reply to Jason Smith [:jsmith] from comment #18)
> > I should clarify - When I say it isn't being localized, I mean not
> > everything is localized. The words "File," "Quit," "Edit", and everything in
> > the application installed notification isn't localized. The menu under the
> > edit menu is localized.
> 
> How was it before bug 762864 landed?

I re-tested this actually on the most recent nightly again. This looks okay now. I cc-ed you on two l10n bugs though that I did recently pick up from testing this. See bug 776362 and bug 776365.
Comment 21 Mike Hommey [:glandium] 2012-07-22 09:22:20 PDT
Comment on attachment 643262 [details] [diff] [review]
Fix webapprt l10n after bug 762864

[Approval Request Comment]
Regression caused by bug 762864 
User impact if declined: Launching web apps doesn't work on non en-US builds
Testing completed (on m-c, etc.): see comments 17, 18 and 20
Risk to taking this patch (and alternatives if risky): Low risk
String or UUID changes made by this patch: None
Comment 22 Mike Hommey [:glandium] 2012-07-24 00:29:46 PDT
http://hg.mozilla.org/releases/mozilla-aurora/rev/ce2e8871ebd8

Note You need to log in before you can comment on or make changes to this bug.